﻿using System;
using System.Windows.Forms;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Text;


namespace CDemoLib
{
    //[ToolboxBitmap(typeof(ConnectTo1Cv8), "config.ico")]
    //[System.Drawing.ToolboxBitmap("config.ico")]
    //[System.Drawing.ToolboxBitmap("config.ico")]
    //[System.Drawing.ToolboxBitmap(typeof(ConnectTo1Cv8), "D:\\work\\C#\\COMPONENTS\\CDemoLib\\config.ico")]
    [System.Drawing.ToolboxBitmap("D:\\work\\C#\\COMPONENTS\\CDemoLib\\config.ico")]
    public partial class ConnectTo1Cv8 : Component
    {
        //Флаг:
        //если true - соединение с программой 1С:Предприятие v8 открыто,
        //в противном случае - false
        private bool fActive;

        //Флаг: если true - окно видимо,
        //в противном случае - нет
        //Актуально только, если fThisConnect_Is_COM := false;
        private bool fVisible;

        //Флаг: Тип соединения.
        //если true - тип соединения : COM-соединение,
        //в противном случае - OLE Automation Client/Server
        private bool fThisConnect_Is_COM;

        //ссылка на 1С:Предприятие v8, как сервер OLE Automation
        private object fole1Cv8;

        //--------------------------------------------------
        //ИНИЦИАЛИЗАЦИЯ ПРОГРАММЫ 1С:ПРЕДПРИЯТИЕ v8

        //строка инициализации программы 1С:Предприятие
        private string fInitStr;

        //Имя программы 1С:Предприятие v8, как сервера OLE Automation
        private string fAppName;

        //Имя Пользователя
        private string fUsr;

        //Пароль для авторизации Пользователя
        private string fPwd;

        //Флаг : если TRUE - то файловый вариант базы данных.
        //В противном случае - клиент-серверный
        private bool fThisDB_Is_Files;

        //............................................
        //Файловый вариант базы данных
        //ПолныйПуть к базе данных
        private string fFile;
        //............................................

        //............................................
        //Клиент-серверный вариант базы данных
        //имя сервера, где запущен сервер приложений 1С
        private string fSrvr;

        //имя базы данных на сервере приложений 1С
        private string fRef;

        //Процедура формирования строки инициализации
        //программы 1С:Предприятие v8
        protected void BuildInitStr()
        {
            //Формирование строки инициализации программы 1С:Предприятие
            fInitStr = "";

            if (fThisConnect_Is_COM)
            {
                fAppName = "V81.COMConnector";
            }
            else
            {
                fAppName = "V81.Application";
            }

            if ( fThisDB_Is_Files )
            {
                fInitStr = fInitStr + " File=" + "\"" + fFile + "\";";
            }
            else
            {
                //Клиент-серверная база данных
                fInitStr = fInitStr + " Srvr=" + "\"" + fSrvr + "\";";
                fInitStr = fInitStr + " Ref=" + "\"" + fRef + "\";";
            }

            fInitStr = fInitStr + " Usr=" + "\"" + fUsr + "\";";
            fInitStr = fInitStr + " Pwd=" + "\"" + fPwd + "\";";
            fInitStr = fInitStr.Trim();
        }    

        //Метод, реализующий подключение (отключение) к 1Cv8,
        //как серверу автоматизации
        protected void mSetActive(bool Value)
        {
            if ( Value != fActive ) 
            {
                //Закрываем программу 1С:Предприятие,
                //как сервер автоматизации (если было COM-соединение)
                //(это нужно для того, чтобы переоткрыть 1Cv8 с новыми значениями ключей запуска)
                fole1Cv8 = null;
                fActive  = false;
                fVisible = false;
                //Формируем строку инициализации
                BuildInitStr();
                if ( Value ) 
                {
                    try
                    {
                        if ( fThisConnect_Is_COM )
                        {
                            //COM-соединение
                            fole1Cv8 = ConnectTo1C8_COM(fAppName, fInitStr);
                            if ( YesLinkToVariant(fole1Cv8) )
                            {
                                fActive = true;
                            }

                        }
                        else
                        {
                            //OLE Automation Client/Server
                            fole1Cv8 = ConnectTo1C8_Application(fAppName, fInitStr, true);
                            if ( YesLinkToVariant(fole1Cv8) ) 
                            {
                                fActive  = true;
                                fVisible = true;
                            }
                        }
                    }
                    catch
                    {
                        MessageBoxButtons buttons = MessageBoxButtons.OK;
                        MessageBox.Show("Не удалось подключиться к информационной базе", "Ошибка", buttons);
                    }

                }
            }
        }

        private object ConnectTo1C8_COM(string s1cAppProgID, string InitLine)
        {
            object Result = new object();

            Object[] arguments = { InitLine };
            
            InitLine = InitLine.Trim();
            if (s1cAppProgID.Length > 0)
            {
                try
                {
                    var v81comConnector = Type.GetTypeFromProgID(s1cAppProgID);
                    var v81 = Activator.CreateInstance(v81comConnector);
                    var x = v81comConnector.InvokeMember("Connect", System.Reflection.BindingFlags.Public | System.Reflection.BindingFlags.InvokeMethod | System.Reflection.BindingFlags.Static, null, v81, arguments);
                    Result = x;
                }
                catch
                {
                    MessageBoxButtons buttons = MessageBoxButtons.OK;
                    MessageBox.Show("Не удалось подключиться к информационной базе", "Ошибка", buttons);
                }
            }
            
            return Result;
        }

        private bool YesLinkToVariant(object HandleAny)
        {
            //if not VarIsEmpty(HandleAny) then Result:=TRUE;
            if (HandleAny == null)
                return false;

            Type t = HandleAny.GetType();

            return t.IsCOMObject ? true : false;
        }

        private object ConnectTo1C8_Application(string s1cAppProgID, string InitLine, bool Visible)
        {
            object Result = new object();
            Object[] arguments = { InitLine };
            InitLine = InitLine.Trim();
            if (s1cAppProgID.Length > 0)
            {
                try
                {
                    //Создаем соединение
                    var v81comConnector = Type.GetTypeFromProgID(s1cAppProgID);
                    var v81 = Activator.CreateInstance(v81comConnector);
                    var x = v81comConnector.InvokeMember("Connect", System.Reflection.BindingFlags.Public | System.Reflection.BindingFlags.InvokeMethod | System.Reflection.BindingFlags.Static, null, v81, arguments);
                    SetObjectProperty(v81, v81, "Visible", true);
                    //Result = v81comConnector;
                    Result = v81;
                }
                catch
                {
                    MessageBoxButtons buttons = MessageBoxButtons.OK;
                    MessageBox.Show("Не удалось подключиться к информационной базе", "Ошибка", buttons);
                }
            }
            return Result;
            
        }

        //Метод, реализующий подключение (отключение) к 1Cv8,
        //Актуально только, если fThisConnect_Is_COM := false;
        protected void mSetVisible(bool Value)
        {
            fVisible = false;
            if ( YesLinkToVariant(fole1Cv8) ) 
            {
                if ( !fThisConnect_Is_COM ) 
                {
                    //Видимость главного окна 1Cv8
                    fVisible = Value;
                    SetObjectProperty(ole1Cv8, ole1Cv8, "Visible", fVisible);
                    //fole1Cv8.Visible = fVisible;
                }
            }
        }

        //метод, "отвечающий" за изменение значения fThisConnect_Is_COM
        protected void mSetThisConnectIsCOM(bool Value)
        {
            fole1Cv8 = null;
            fActive  = false;
            fVisible = false;
            fThisConnect_Is_COM  = Value;

            if (fThisConnect_Is_COM)
            {
                fAppName = "V81.COMConnector";
            }
            else
            {
                fAppName = "V81.Application";
            }
            BuildInitStr();
        }

        //метод, "отвечающий" за изменение значения fAppName
        protected void mSetAppName(string Value)
        {
            fole1Cv8 = null;
            fActive  = false;
            fVisible = false;
            fAppName = Value;
            BuildInitStr(); 
        }

        //метод, "отвечающий" за изменение значения fUsr
        protected void mSetUsr(string Value)
        {
            fole1Cv8 = null;
            fActive  = false;
            fVisible = false;
            fUsr = Value;
            BuildInitStr(); 
        }

        //метод, "отвечающий" за изменение значения fPwd
        protected void mSetPwd(string Value)
        {
            fole1Cv8 = null;
            fActive  = false;
            fVisible = false;
            fPwd = Value;
            BuildInitStr(); 
        }

        //метод, "отвечающий" за изменение значения fThisDB_Is_Files 
        protected void mSetThisDBisFiles(bool Value)
        {
            fole1Cv8 = null;
            fActive  = false;
            fVisible = false;
            fThisDB_Is_Files = Value;
            BuildInitStr(); 
        }

        //метод, "отвечающий" за изменение значения fFile
        protected void mSetFile(string Value)
        {
            fole1Cv8 = null;
            fActive  = false;
            fVisible = false;
            fFile = Value;
            BuildInitStr(); 
        }

        //метод, "отвечающий" за изменение значения fSrvr
        protected void mSetSrvr(string Value)
        {
            fole1Cv8 = null;
            fActive  = false;
            fVisible = false;
            fSrvr = Value;
            BuildInitStr(); 
        }

        //метод, "отвечающий" за изменение значения fRef
        protected void mSetRef(string Value)
        {
            fole1Cv8 = null;
            fActive  = false;
            fVisible = false;
            fRef = Value;
            BuildInitStr(); 
        }

        public object GetObjectProperty(object v81, object refObject, string propertyName)
        {
            return v81.GetType().InvokeMember(propertyName, System.Reflection.BindingFlags.GetProperty, null, refObject, null);
        }

        public void SetObjectProperty(object v81, object refObject, string propertyName, object val)
        {
            v81.GetType().InvokeMember(propertyName, System.Reflection.BindingFlags.SetProperty, null, v81, new object[] { val });
        }

        public object InvokeObjectMethod(object v81, object refObject, string methodName, Object[] parameters)
        {
            return v81.GetType().InvokeMember(methodName, System.Reflection.BindingFlags.Public | System.Reflection.BindingFlags.InvokeMethod | System.Reflection.BindingFlags.Static, null, refObject, parameters);
        }

        //Свойство Active компонента
        //(подключение (отключение) к 1Cv8,как серверу автоматизации)
        //property Active: boolean read fActive write mSetActive;
        [Description("Активно ли подключение к 1С в данный момент")]
        public bool Active
        {
            get { return fActive; }
            set { mSetActive(value); }
        }

        //Свойство Visible1Cv8 компонента
        //(Визуализация окна 1Cv8)
        //Актуально только, если ThisConnect_Is_COM := false;
        [Description("Устанавливает видимость окна приложения 1С")]
        public bool Visible1Cv8
        {
            get { return fVisible; }
            set { mSetVisible(value); }
        }

        //Флаг: Тип соединения.
        //если true - тип соединения : COM-соединение,
        //в противном случае - OLE Automation Client/Server
        [Description("Устанавливает тип соединения, либо COM-соединение, либо OLE Automation Client/Server")]
        public bool ThisConnect_Is_COM
        {
            get { return fThisConnect_Is_COM; }
            set { mSetThisConnectIsCOM(value); }
        }

        //Имя программы 1С:Предприятие v 8, как сервера автоматизации
        [Description("Устанавливает имя программы 1С, как сервера автоматизации, либо COM-соединение, либо OLE Automation Client/Server")]
        public string AppName1Cv8
        {
            get { return fAppName; }
            set { mSetAppName(value); }
        }

        //Имя Пользователя
        [Description("Устанавливает пользователя 1С под которым осуществляем вход в 1С")]
        public string UserName
        {
            get { return fUsr; }
            set { mSetUsr(value); }
        }

        //Пароль для авторизации Пользователя
        [Description("Устанавливает пароль пользователя 1С под которым осуществляем вход в 1С")]
        public string Password
        {
            get { return fPwd; }
            set { mSetPwd(value); }
        }

        //Вариант базы данных.
        //Если TRUE - то файловый вариант базы данных.
        //В противном случае - клиент-серверный
        [Description("Устанавливает признак того что база 1С в файловом варианте")]
        public bool ThisDB_Is_Files
        {
            get { return fThisDB_Is_Files; }
            set { mSetThisDBisFiles(value); }
        }

        //ПолныйПуть к базе данных
        //(если файловый вариант базы данных)
        [Description("Указывает на каталог базы данных 1С, если вариант файловый")]
        public string FilePath
        {
            get { return fFile; }
            set { mSetFile(value); }
        }

        //имя сервера, где запущен сервер приложений 1С
        //(если клиент-серверный вариант базы данных)
        [Description("Указывает имя сервера 1С, к которому будем подключаться")]
        public string Server
        {
            get { return fSrvr; }
            set { mSetSrvr(value); }
        }

        //имя базы данных на сервере приложений 1С
        //(если клиент-серверный вариант базы данных)
        [Description("Указывает имя базы на сервере 1С, к которому будем подключаться")]
        public string Database
        {
            get { return fRef; }
            set { mSetRef(value); }
        }

        [Description("COM объект 1С, через который можно обращаться к методам 1С Предприятия")]
        public object ole1Cv8
        {
            get { return fole1Cv8; }
        }
        ///////////////////////////////////////////////////////////////////////////////////////////////////

        // Конструктор по умолчанию
        public ConnectTo1Cv8()
        {
            InitializeComponent();
            //---------------------------------------
            //Инициализация начальных значений соответствующих свойств
            fole1Cv8 = null;
            fActive = false;
            fVisible = false;

            fThisConnect_Is_COM  = false;
            fThisDB_Is_Files  = true;
            if (fThisConnect_Is_COM)
            {
                fAppName = "V81.COMConnector";
            }
            else
            {
                fAppName = "V81.Application";
            }
            
            //---------------------------------------

            //Формируем строку инициализации
            BuildInitStr();

        }

        // Есчё один конструктор
        public ConnectTo1Cv8(IContainer container)
        {
            container.Add(this);

            InitializeComponent();
        }

        //
        ~ConnectTo1Cv8()
        {
            //Закрываем программу 1С:Предприятие,
            //как сервер автоматизации
            //(если тип соединения был: COM)
            fole1Cv8 = null;

            fActive  = false;
            fVisible = false;
        }

    }
}
